# Makefile for Zip, ZipCloak, ZipNote and ZipSplit              3 March 2007
#
# Makefile for eComstation zip.exe using OpenWatcom 1.6 and above
#
# Michael K Greene <greenemk@cox.net>
#
# Targets:
#   all     - all files
#   release - all files and exe files lxlite compressed
#   debug   - debug build of all files
#   zipit   - all files, exe files lxlite compressed,
#             zip to acrchive zip232.zip
#
#----------------------------------------------------------------------------

CC = wcc386
LD = wlink

MACHINE= -6s -fp6

COMMONDEFS = -D__ECS__ -DOS2 -DNO_ASM

!ifdef %UNZIPDEBUG
DEBUG = 1
!endif

!ifndef DEBUG
LDDEBUG   = op el
CDEBUG    = -d0
OPT       = -otbmilera  #-otexan
DEFS      = $(COMMONDEFS)
!else
LDDEBUG   = d all op map op symf
CDEBUG    = -d3 -v
OPT       = -od
DEFS      = $(COMMONDEFS) -DDEBUG
!endif

INCLUDE  = .\;..\;$(%watcom)\h;$(%watcom)\h\os2
CFLAGS   = -i=$(INCLUDE) $(DEFS) $(CDEBUG) -za99 -wx -e25 -zq $(OPT) $(MACHINE) -bt=OS2 -mf -bm
LDFLAGS  = $(LDDEBUG) op maxe=25,st=0x50000

OBJZ  = zip.obj zipfile.obj zipup.obj fileio.obj util.obj globals.obj crypt.obj &
        crctab.obj ttyio.obj deflate.obj trees.obj crc32.obj

OBJ2  = os2zip.obj os2.obj os2acl32.obj

OBJU  = zipfile_.obj fileio_.obj util_.obj globals.obj

OBJU2 = os2zip_.obj

OBJN  = zipnote.obj $(OBJU) $(OBJU2)
OBJS  = zipsplit.obj $(OBJU) $(OBJU2)
OBJC  = zipcloak.obj crctab.obj crypt_.obj ttyio.obj $(OBJU) $(OBJU2)

.c:.;.\os2

.c.obj:
  $(CC) $(CFLAGS) $<

default: .SYMBOLIC
  @echo Targets:
  @echo   all     - all files
  @echo   release - all files and exe files lxlite compressed
  @echo   debug   - debug build of all files
  @echo   zipit   - all files, exe files lxlite compressed,
  @echo             zip to acrchive zip232.zip

all: exe .SYMBOLIC

release: exe zip.inf pack .SYMBOLIC

debug: exed .SYMBOLIC

exe: zip.exe zipsplit.exe zipnote.exe zipcloak.exe .SYMBOLIC

exed: .SYMBOLIC
  set UNZIPDEBUG=1
  wmake -f os2\makefile.wat exe

zipit: release ziparchive .SYMBOLIC


zip.exe: $(OBJZ) $(OBJ2)
  $(LD) NAME zip SYS os2v2 $(LDFLAGS) LIB netapi32.lib FILE {$(OBJZ) $(OBJ2)}

zipsplit.exe: $(OBJS)
  $(LD) NAME zipsplit SYS os2v2 $(LDFLAGS) FILE {$(OBJS)}

zipnote.exe: $(OBJN)
  $(LD) NAME zipnote SYS os2v2 $(LDFLAGS) FILE {$(OBJN)}

zipcloak.exe: $(OBJC)
  $(LD) NAME zipcloak SYS os2v2 $(LDFLAGS) FILE {$(OBJC)}

zip.inf:
  ipfc -i .\os2\zip.ipf .\zip.inf

zipfile_.obj:
  $(CC) $(CFLAGS) -DUTIL -fo=zipfile_.obj zipfile.c

fileio_.obj:
  $(CC) $(CFLAGS) -DUTIL -fo=fileio_.obj fileio.c

util_.obj:
  $(CC) $(CFLAGS) -DUTIL -fo=util_.obj util.c

crypt_.obj:
  $(CC) $(CFLAGS) -DUTIL -fo=crypt_.obj crypt.c

os2zip_.obj:
  $(CC) $(CFLAGS) -DUTIL -fo=os2zip_.obj .\os2\os2zip.c

pack: .SYMBOLIC
  -lxlite zip.exe
  -lxlite zipsplit.exe
  -lxlite zipnote.exe
  -lxlite zipcloak.exe

ziparchive: .SYMBOLIC
  zip -9 -D -j zip232.zip zip.exe zipsplit.exe zipnote.exe &
                  zipcloak.exe zip.inf os2\readme.wat


clean : .SYMBOLIC
  -@rm *.exe
  -@rm *.inf
  @%make cleanrel

cleanrel : .PROCEDURE
  -@rm *.obj
  -@rm *.def
  -@rm *.sym
  -@rm *.err
  -@rm *.lst
  -@rm *.map
  -@rm *.err


