:userdoc.
:docprof toc=1234.
:title.ZIP 2.32 Man Page

:h1.Introduction
:p.
:hp2.
.ce zip, zipcloak, zipnote, zipsplit &hyphen. package and compress (archive) files
.ce 19 June 2006 (v2.32)
:ehp2.

SYNOPSIS
:p.zip   [-aABcdDeEfFghjklLmoqrRSTuvVwXyz!@$]   [-b path]    [-n suffixes]
.br
       [-t mmddyyyy] [-tt mmddyyyy] [ zipfile [ file1 file2 ...]] [-xi list]
:p.zipcloak [-dhL] [-b path] zipfile
:p.zipnote [-hwL] [-b path] zipfile
:p.zipsplit [-hiLpst] [-n size] [-b path] zipfile


:h1.Description
:p.zip  is  a compression and file packaging utility for Unix, VMS, MSDOS,
OS/2, Windows NT, Minix, Atari and Macintosh, Amiga and Acorn RISC  OS.
:p.It is analogous to a combination of the UNIX commands tar(1) and compress(1)
and is compatible with PKZIP (Phil Katz's ZIP for MSDOS systems).
:p.A companion program (unzip(1L)), unpacks zip archives.  The zip and
unzip(1L) programs can work with archives produced by PKZIP, and PKZIP
and PKUNZIP can work with archives produced by zip.  zip version 2.32
is compatible with PKZIP 2.04.  Note that PKUNZIP 1.10 cannot extract
files produced by PKZIP 2.04 or zip 2.32. You must use PKUNZIP 2.04g or
unzip 5.0p1 (or later versions) to extract them.
:p.For a brief help on zip and unzip, run each without specifying any
parameters on the command line.
:p.The  program  is  useful for packaging a set of files for distribution;
for archiving files; and for saving disk space by temporarily compressing
unused files or directories.
:p.The  zip  program  puts  one or more compressed files into a single zip
archive, along with information about the files (name, path, date, time
of  last modification, protection, and check information to verify file
integrity).  An entire directory structure can be  packed  into  a  zip
archive  with  a  single command.  Compression ratios of 2&colon.1 to 3&colon.1 are
common for text files.  zip has one compression method (deflation)  and
can  also  store  files without compression.  zip automatically chooses
the better of the two for each file to be compressed.
:p.The basic command format is
:p.       zip options archive inpattern inpattern ...
:p.where archive is a new or existing  zip  archive  and  inpattern  is  a
directory  or file path optionally including wildcards.  When given the
name of an existing zip archive, zip  will  replace  identically  named
entries  in the zip archive or add entries for new names.  For example,
if foo.zip exists and contains foo/file1 and foo/file2, and the  directory
foo contains the files foo/file1 and foo/file3, then&colon.
:p.       zip -r foo.zip foo
:p.or more concisely
:p.       zip -r foo foo
:p.will  replace foo/file1 in foo.zip and add foo/file3 to foo.zip.  After
this,  foo.zip  contains  foo/file1,  foo/file2,  and  foo/file3,  with
foo/file2 unchanged from before.
:p.If  the file list is specified as -@, [Not on MacOS] zip takes the list
of input files from standard input.  Under UNIX,  this  option  can  be
used  to  powerful effect in conjunction with the find(1) command.  For
example, to archive all the C source files in the current directory and
its subdirectories&colon.
:p.       find . -name "*.[ch]" -print | zip source -@
:p.(note  that  the pattern "*.[ch]" must be quoted to keep the shell from
expanding it).  zip will also accept a single dash  ("-")  as  the  zip
file name, in which case it will write the zip file to standard output,
allowing the output to be piped to another program. For example&colon.
:p.       zip -r - . | dd of=/dev/nrst0 obs=16k
:p.would write the zip output directly to a tape with the specified  block
size for the purpose of backing up the current directory.
:p.zip  also  accepts a single dash ("-") as the name of a file to be
compressed, in which case it will  read  the  file  from  standard  input,
allowing zip to take input from another program. For example&colon.
:p.       tar cf - . | zip backup -
:p.would compress the output of the tar command for the purpose of backing
up the current directory. This generally  produces  better  compression
than  the  previous  example  using the -r option, because zip can take
advantage of redundancy between files. The backup can be restored using
the command
:p.       unzip -p backup | tar xf -
:p.When no zip file name is given and stdout is not a terminal, zip acts
as a filter, compressing standard input to standard output.  For example,
:p.       tar cf - . | zip | dd of=/dev/nrst0 obs=16k

:p.is equivalent to

:p.       tar cf - . | zip - &hyphen. | dd of=/dev/nrst0 obs=16k
zip  archives  created in this manner can be extracted with the program
funzip which is provided in the unzip package, or by  gunzip  which  is
provided in the gzip package. For example&colon.
:p.       dd if=/dev/nrst0  ibs=16k | funzip | tar xvf -
:p.When  changing an existing zip archive, zip will write a temporary file
with the new contents, and only replace the old one when the process of
creating the new version has been completed without error.
:p.If  the  name  of  the  zip  archive does not contain an extension, the
extension .zip is added. If the  name  already  contains  an  extension
other than .zip the existing extension is kept unchanged.

:h1.Options
:p. zip.exe command line option.

:h2.&hyphen.a

:p.[Systems using EBCDIC] Translate file to ASCII format.
.br

:h2.&hyphen.A
:p.Adjust  self&hyphen.extracting  executable  archive.  A self&hyphen.extracting
executable archive is created by prepending the SFX stub  to  an
existing  archive.  The  &hyphen.A option tells zip to adjust the entry
offsets  stored  in  the  archive  to  take  into  account  this
"preamble" data.

:p.Note:  self&hyphen.extracting  archives  for the Amiga are a special case.  At
present, only the Amiga port of zip is capable of adjusting or updating
these  without  corrupting them.  &hyphen.J can be used to remove the SFX stub
if other updates need to be made.
.br

:h2.&hyphen.B
:p.[VM/CMS and MVS] force file to be read binary (default is text).
.br

:h2.&hyphen.Bn
:p.[TANDEM] set Edit/Enscribe formatting options with n defined as
.br
bit 0: Don't add delimiter (Edit/Enscribe)
.br
bit 1: Use LF rather than CR/LF as delimiter (Edit/Enscribe)
.br
bit 2: Space fill record to maximum record length (Enscribe)
.br
bit 3: Trim trailing space (Enscribe)
.br
bit 8: Force 30K (Expand) large read for unstructured files
.br

:h2.&hyphen.b path
:p.Use  the specified path for the temporary zip archive. For example:

:p.       zip &hyphen.b /tmp stuff *

:p.will put the temporary zip archive in the directory /tmp,  copying
over  stuff.zip  to  the  current directory when done. This
option is only useful when updating an existing archive, and the
file  system  containing  this  old archive does not have enough
space to hold both old and new archives at the same time.
.br

:h2.&hyphen.c
:p.Add one&hyphen.line comments for each file.  File  operations  (adding,
updating)  are  done  first, and the user is then prompted for a
one&hyphen.line comment for each file.  Enter the comment  followed  by
return, or just return for no comment.
.br

:h2.&hyphen.d
:p.Remove (delete) entries from a zip archive.  For example:

:p.       zip &hyphen.d foo foo/tom/junk foo/harry/\* \*.o

:p.will  remove the entry foo/tom/junk, all of the files that start
with foo/harry/, and all of the files that end with .o  (in  any
path).   Note  that  shell pathname expansion has been inhibited
with backslashes, so that zip can see  the  asterisks,  enabling
zip  to  match on the contents of the zip archive instead of the
contents of the current directory.  You can also use  quotes  to
escape wildcards, as in

:p.       zip &hyphen.d foo foo/tom/junk "foo/harry/*" "*.o"

:p.Under systems where the shell does not expand wildcards, such as
MSDOS, the backslashes are not needed.  The above would then be

:p.       zip &hyphen.d foo foo/tom/junk foo/harry/* *.o

:p.Under MSDOS, &hyphen.d is case sensitive when it matches names  in  the
zip  archive.  This requires that file names be entered in upper
case if they were zipped by PKZIP on an MSDOS system.
.br

:h2.&hyphen.df
[MacOS] Include only data&hyphen.fork of files zipped into the archive.
Good   for   exporting   files   to  foreign  operating&hyphen.systems.
Resource&hyphen.forks will be ignored at all.
.br

:h2.&hyphen.D
:p.Do not create  entries  in  the  zip  archive  for  directories.
Directory   entries   are  created  by  default  so  that  their
attributes can be saved in the  zip  archive.   The  environment
variable  ZIPOPT  can be used to change the default options. For
example under Unix with sh:

:p.       ZIPOPT="&hyphen.D"; export ZIPOPT

:p.(The variable ZIPOPT can be used for any option except &hyphen.i and &hyphen.x
and  can  include several options.) The option &hyphen.D is a shorthand
for &hyphen.x "*/" but the latter cannot  be  set  as  default  in  the
ZIPOPT environment variable.
.br

:h2.&hyphen.e
Encrypt  the  contents of the zip archive using a password which
is entered on the terminal in response to a  prompt  (this  will
not  be  echoed;  if  standard error is not a tty, zip will exit
with an error).  The password prompt is  repeated  to  save  the
user  from typing errors.  Note that this encrypts with standard
pkzip encryption which is considered weak.
.br

:h2.&hyphen.E
[OS/2] Use the .LONGNAME Extended Attribute (if found) as  filename.
.br

:h2.&hyphen.f
:p.Replace  (freshen)  an existing entry in the zip archive only if
it has been modified more recently than the version  already  in
the  archive;  unlike  the  update option (&hyphen.u) this will not add
files that are not already in the zip archive.  For example:

:p.       zip &hyphen.f foo

:p.This command should be run from the same  directory  from  which
the  original  zip  command  was  run, since paths stored in zip
archives are always relative.

:p.Note that the timezone environment variable  TZ  should  be  set
according  to the local timezone in order for the &hyphen.f , &hyphen.u and &hyphen.o
options to work correctly.  The reasons behind this are somewhat
subtle but have to do with the differences between the Unix&hyphen.for&hyphen.
mat file times (always in GMT) and most of the  other  operating
systems  (always  local  time)  and the necessity to compare the
two.  A typical TZ value is ``MET&hyphen.1MEST'' (Middle European  time
with automatic adjustment for ``summertime'' or Daylight Savings
Time).
.br

:h2.&hyphen.F
:p.Fix the zip archive. This option can be used if some portions of
the  archive  are  missing. It is not guaranteed to work, so you
MUST make a backup of the original archive first.

:p.When doubled as in &hyphen.FF the compressed  sizes  given  inside  the
damaged archive are not trusted and zip scans for special signa&hyphen.
tures to identify the limits between the  archive  members.  The
single  &hyphen.F  is more reliable if the archive is not too much dam&hyphen.
aged, for example if it has only been  truncated,  so  try  this
option first.

:p.Neither  option will recover archives that have been incorrectly
transferred in ascii mode instead of binary. After  the  repair,
the  &hyphen.t option of unzip may show that some files have a bad CRC.
Such files cannot be recovered; you can  remove  them  from  the
archive using the &hyphen.d option of zip.
.br

:h2.&hyphen.g
:p.Grow  (append to) the specified zip archive, instead of creating
a new one. If this operation fails, zip attempts to restore  the
archive  to  its  original  state. If the restoration fails, the
archive might become corrupted.  This  option  is  ignored  when
there's  no existing archive or when at least one archive member
must be updated or deleted.
.br

:h2.&hyphen.h
:p.Display the zip help information (this also appears  if  zip  is run with no arguments).
.br

:h2.&hyphen.i files
:p.Include only the specified files, as in:

:p.       zip &hyphen.r foo . &hyphen.i \*.c

:p.which  will include only the files that end in .c in the current
directory and its subdirectories. (Note  for  PKZIP  users:  the
equivalent command is

:p.       pkzip &hyphen.rP foo *.c

:p.PKZIP  does  not  allow  recursion in directories other than the
current one.)  The backslash avoids the shell filename substitu&hyphen.
tion,  so  that  the  name  matching  is performed by zip at all
directory levels.  Not escaping  wildcards  on  shells  that  do
wildcard  substitution before zip gets the command line may seem
to work but files in subdirectories matching  the  pattern  will
never  be checked and so not matched.  For shells, such as Win32
command prompts, that do not replace  file  patterns  containing
wildcards with the respective file names, zip will do the recur&hyphen.
sion and escaping the wildcards is not needed.

:p.Also possible:

:p.       zip &hyphen.r foo  . &hyphen.i@include.lst

:p.which will only include the files in the current  directory  and
its   subdirectories   that  match  the  patterns  in  the  file
include.lst, one file pattern per line.
.br

:h2.&hyphen.I
:p.[Acorn RISC OS] Don't scan through Image files.  When used,  zip
will  not  consider  Image  files  (eg.  DOS partitions or Spark
archives when SparkFS is loaded) as directories but  will  store
them as single files.
.br

:p.For example, if you have SparkFS loaded, zipping a Spark archive
will result in a zipfile containing a directory  (and  its  content)
while  using the 'I' option will result in a zipfile containing a Spark
archive. Obviously this second case will also be
obtained (without the 'I' option) if SparkFS isn't loaded.
.br

:h2.&hyphen.j
:p.Store  just the name of a saved file (junk the path), and do not
store directory names. By default, zip will store the full  path
(relative to the current path).
.br

:h2.&hyphen.jj
:p.[MacOS] record Fullpath (+ Volname). The complete path including
volume will be stored. By default  the  relative  path  will be stored.
.br

:h2.&hyphen.J
:p.Strip any prepended data (e.g. a SFX stub) from the archive.
.br

:h2.&hyphen.k
:p.Attempt  to  convert  the  names  and paths to conform to MSDOS,
store only the MSDOS attribute (just the  user  write  attribute
from  UNIX), and mark the entry as made under MSDOS (even though
it was not); for compatibility with PKUNZIP  under  MSDOS  which
cannot handle certain names such as those with two dots.
.br

:h2.&hyphen.l
:p.Translate  the Unix end&hyphen.of&hyphen.line character LF into the MSDOS convention
CR LF. This option should not be used on  binary  files.
This  option can be used on Unix if the zip file is intended for
PKUNZIP under MSDOS. If the input files already contain  CR  LF,
this option adds an extra CR. This ensures that unzip &hyphen.a on Unix
will get back an exact copy of the original file,  to  undo  the
effect  of  zip  &hyphen.l.   See  the note on binary detection for &hyphen.ll
below.
.br

:h2.&hyphen.ll
:p.Translate the MSDOS end&hyphen.of&hyphen.line CR LF into Unix LF.  This option
should  not be used on binary files and a warning will be issued
when a file is converted that later is detected  to  be  binary.
This option can be used on MSDOS if the zip file is intended for
unzip under Unix.

:p.In Zip 2.31 and later, binary detection has been changed from  a
simple  percentage  of binary characters being considered binary
to a more selective method that should consider  files  in  many
character  sets, including UTF&hyphen.8, that only include text charac&hyphen.
ters in that character set to be text.  This allows unzip &hyphen.a  to
convert these files.
.br

:h2.&hyphen.L
:p.Display the zip license.
.br

:h2.&hyphen.m
:p.Move  the  specified  files into the zip archive; actually, this
deletes the target directories/files after making the  specified
zip  archive.  If a directory becomes empty after removal of the
files, the directory is also  removed.  No  deletions  are  done
until zip has created the archive without error.  This is useful
for conserving disk space, but is potentially dangerous so it is
recommended to use it in combination with &hyphen.T to test the archive
before removing all input files.
.br

:h2.&hyphen.MM
:p.All input patterns must match at least one file  and  all  input
files  found  must  be readable.  Normally when an input pattern
does not match a file the "name not matched" warning  is  issued
and  when  an  input file has been found but later is missing or
not readable a missing or not readable warning  is  issued.   In
either  case zip continues creating the archive, with missing or
unreadable new files being skipped  and  files  already  in  the
archive  remaining  unchanged.  After the archive is created, if
any files were not readable zip returns the OPEN error code  (18
on most systems) instead of the normal success return (0 on most
systems).  With &hyphen.MM set, zip exits as soon as an  input  pattern
is not matched (whenever the "name not matched" warning would be
issued) or when an input file is not readable.  In  either  case
zip exits with an OPEN error and no archive is created.

:p.This option is useful when a known list of files is to be zipped
so any missing or unreadable files will result in an error.   It
is less useful when used with wildcards, but zip will still exit
with an error if any input pattern doesn't match  at  least  one
file  and  if  any matched files are unreadable.  If you want to
create the archive anyway and only need to know  if  files  were
skipped, don't use &hyphen.MM and just check the return code.
.br

:h2.&hyphen.n suffixes
:p.Do  not attempt to compress files named with the given suffixes.
Such files are simply stored (0% compression) in the output  zip
file,  so  that  zip  doesn't  waste its time trying to compress
them.  The suffixes are separated  by  either  colons  or  semi&hyphen.
colons.  For example:

:p.       zip &hyphen.rn .Z&colon..zip&colon..tiff&colon..gif&colon..snd  foo foo

:p.will  copy  everything from foo into foo.zip, but will store any
files that end in .Z, .zip, .tiff, .gif, or .snd without  trying
to  compress  them  (image  and sound files often have their own
specialized compression methods).  By default, zip does not compress
files with extensions in the list
&dot.Z&colon.&dot.zip&colon.&dot.zoo&colon.&dot.arc&colon.&dot.lzh&colon.&dot.arj&dot.  Such files are stored directly  in
the output archive.  The environment variable ZIPOPT can be used
to change the default options. For example under Unix with csh:

:p.       setenv ZIPOPT "&hyphen.n &dot.gif&colon.&dot.zip"

:p.To attempt compression on all files, use:

:p.       zip &hyphen.n : foo

:p.The maximum compression option &hyphen.9 also attempts  compression  on
all files regardless of extension.

:p.On  Acorn RISC OS systems the suffixes are actually filetypes (3
hex digit format). By default, zip does not compress files  with
filetypes  in the list DDC&colon.D96&colon.68E (i.e. Archives, CFS files and
PackDir files).
.br

:h2.&hyphen.N
:p.[Amiga, MacOS] Save Amiga or MacOS  filenotes  as  zipfile  comments.
They can be restored by using the &hyphen.N option of unzip. If &hyphen.c is used also,
you are prompted for comments only for those files that do not have filenotes.
.br

:h2.&hyphen.o
:p.Set  the  "last  modified" time of the zip archive to the latest
(oldest) "last modified" time found among the entries in the zip
archive.   This  can  be  used  without any other operations, if
desired.  For example:

:p.       zip &hyphen.o foo

:p.will change the last modified time of foo.zip to the latest time
of the entries in foo.zip.
.br

:h2.&hyphen.P password
:p.use password to encrypt zipfile entries (if any).  THIS IS INSECURE!
Many multi&hyphen.user operating systems provide  ways  for  any
user  to see the current command line of any other user; even on
stand&hyphen.alone systems there is  always  the  threat  of  over&hyphen.the&hyphen.
shoulder  peeking.   Storing the plaintext password as part of a
command line in an automated script  is  even  worse.   Whenever
possible, use the non&hyphen.echoing, interactive prompt to enter pass&hyphen.
words.  (And where  security  is  truly  important,  use  strong
encryption such as Pretty Good Privacy instead of the relatively
weak encryption provided by standard zipfile utilities.)
.br

:h2.&hyphen.q
:p.Quiet mode; eliminate informational messages and comment prompts.
(Useful, for example, in shell scripts and background tasks).
.br

:h2.&hyphen.Qn
:p.[QDOS] store information about the file in the file header  with n defined as
:p.       bit  0: Don't add headers for any file
:p.       bit  1: Add headers for all files
:p.       bit  2: Don't wait for interactive key press on exit
.br

:h2.&hyphen.r
:p.Travel the directory structure recursively; for example:

:p.       zip &hyphen.r foo.zip foo

:p.or a bit more concisely

:p.       zip &hyphen.r foo foo

:p.In  this case, all the files and directories in foo are saved in
a zip archive named foo.zip, including files with names starting
with ".", since the recursion does not use the shell's file&hyphen.name
substitution mechanism.  If you wish to include only a  specific
subset of the files in directory foo and its subdirectories, use
the &hyphen.i option to specify the pattern of files  to  be  included.
You  should  not  use  &hyphen.r with the name ".*", since that matches
".."  which will attempt to zip up the parent directory  (probably not what was intended).
.br

:h2.&hyphen.R
:p.Travel  the directory structure recursively starting at the current directory; for example:

:p.       zip &hyphen.R foo '*.c'

:p.In this case, all the files matching *.c in the tree starting at
the  current  directory  are  stored  into  a  zip archive named
foo.zip.  Note for PKZIP users: the equivalent command is

:p.       pkzip &hyphen.rP foo *.c
.br

:h2.&hyphen.S
:p.[MSDOS, OS/2, WIN32 and ATARI] Include system and hidden  files.
:p.[MacOS]  Includes finder invisible files, which are ignored otherwise.
.br

:h2.&hyphen.t mmddyyyy
:p.Do not operate on files modified prior to  the  specified  date,
where mm is the month (0&hyphen.12), dd is the day of the month (1&hyphen.31),
and yyyy is the year.  The ISO 8601 date  format  yyyy&hyphen.mm&hyphen.dd  is
also accepted.  For example:

:p.       zip &hyphen.rt 12071991 infamy foo

:p.       zip &hyphen.rt 1991&hyphen.12&hyphen.07 infamy foo

:p.will  add  all the files in foo and its subdirectories that were
last modified on or after 7 December 1991, to  the  zip  archive
infamy.zip.
.br

:h2.&hyphen.tt mmddyyyy
:p.Do not operate on files modified after or at the specified date,
where mm is the month (0&hyphen.12), dd is the day of the month (1&hyphen.31),
and  yyyy  is  the year.  The ISO 8601 date format yyyy&hyphen.mm&hyphen.dd is
also accepted.  For example:

:p.       zip &hyphen.rtt 11301995 infamy foo

:p.       zip &hyphen.rtt 1995&hyphen.11&hyphen.30 infamy foo

:p.will add all the files in foo and its subdirectories  that  were
last  modified  before  30  November  1995,  to  the zip archive
infamy.zip.
.br

:h2.&hyphen.T
:p.Test the integrity of the new zip file. If the check fails, the old
zip file is unchanged and (with the &hyphen.m option) no input files are removed.
.br

:h2.&hyphen.u
:p.Replace (update) an existing entry in the zip archive only if it
has  been modified more recently than the version already in the
zip archive.  For example:

:p.       zip &hyphen.u stuff *

:p.will add any new files in the current directory, and update  any
files  which  have been modified since the zip archive stuff.zip
was last created/modified (note that zip will not  try  to  pack
stuff.zip into itself when you do this).

:p.Note  that  the  &hyphen.u  option  with  no arguments acts like the &hyphen.f
(freshen) option.
.br

:h2.&hyphen.v
:p.Verbose mode or print diagnostic version info.

:p.Normally, when applied to real operations, this  option  enables
the  display  of  a  progress  indicator  during compression and
requests verbose diagnostic info about zipfile  structure  oddities.

:p.When  &hyphen.v  is the only command line argument, and either stdin or
stdout is not redirected to  a  file,  a  diagnostic  screen  is
printed.  In  addition  to  the  help screen header with program
name, version, and release date, some pointers to  the  Info&hyphen.ZIP
home  and  distribution sites are given. Then, it shows information
about the target environment (compiler type and version, OS
version, compilation date and the enabled optional features used
to create the zip executable.
.br

:h2.&hyphen.V
:p.[VMS] Save VMS file  attributes  and  use  portable  form.   zip
archives created with this option are truncated at EOF but still
may not be usable on other systems depending on the  file  types
being zipped.
.br

:h2.&hyphen.VV
:p.[VMS]  Save VMS file attributes.  zip archives created with this
option include the entire file and should be  able  to  recreate
most  VMS files on VMS systems but these archives will generally
not be usable on other systems.
.br

:h2.&hyphen.w
:p.[VMS] Append the version  number  of  the  files  to  the  name,
including  multiple  versions  of files.  (default: use only the
most recent version of a specified file).
.br

:h2.&hyphen.x files
:p.Explicitly exclude the specified files, as in:

:p.       zip &hyphen.r foo foo &hyphen.x \*.o

:p.which will include the contents of foo in foo.zip while  excluding
all  the  files  that  end in .o.  The backslash avoids the
shell filename substitution, so that the name matching  is  performed
by  zip  at  all directory levels.  If you do not escape
wildcards in patterns it may seem to work but files in subdirectories
will not be checked for matches.

:p.Also possible:

:p.       zip &hyphen.r foo foo &hyphen.x@exclude.lst

:p.which  will include the contents of foo in foo.zip while excluding
all  the  files  that  match  the  patterns  in  the   file
exclude.lst (each file pattern on a separate line).
.br

:h2.&hyphen.X
:p.Do  not save extra file attributes (Extended Attributes on OS/2, uid/gid and file times on Unix).
.br

:h2.&hyphen.y
:p.Store symbolic links as such in the zip archive, instead of compressing and  storing the
file  referred to by the link (UNIX only).
.br

:h2.&hyphen.z
:p.Prompt for a multi&hyphen.line comment for the entire zip archive.  The
comment  is  ended by a line containing just a period, or an end
of file condition (^D on UNIX, ^Z on MSDOS, OS/2, and VMS).  The
comment can be taken from a file:

:p.       zip &hyphen.z foo < foowhat
.br

:h2.&hyphen.#
:p.Regulate  the  speed of compression using the specified digit #, where &hyphen.0
indicates no compression (store all  files),  &hyphen.1  indicates  the  fastest
compression method (less compression) and &hyphen.9 indicates the slowest compression
method  (optimal  compression, ignores the suffix list). The default compression level is &hyphen.6.
.br

:h2.&hyphen.!
:p.[WIN32]  Use  priviliges  (if  granted) to obtain all aspects of WinNT security.
.br

:h2.&hyphen.@
:p.Take the list of input files from standard input. Only one filename per line.
.br

:h2.&hyphen.$
:p.[MSDOS,  OS/2,  WIN32]  Include  the  volume label for the drive holding the first
file to be compressed.  If you want to include only  the  volume  label  or  to
force a specific drive, use the drive name as first file name, as in:

:p.       zip &hyphen.$ foo a&colon. c&colon.bar
.br


:h1.Examples
:p.The simplest example:

:p.       zip stuff *

:p.creates the archive stuff.zip (assuming it does not exist) and puts all
the  files in the current directory in it, in compressed form (the .zip
suffix is added automatically, unless that archive name given  contains
a  dot  already;  this  allows the explicit specification of other suf&hyphen.
fixes).

:p.Because of the way the shell does filename substitution, files starting
with "." are not included; to include these as well:

:p.       zip stuff .* *

:p.Even  this  will not include any subdirectories from the current directory.

:p.To zip up an entire directory, the command:

:p.       zip &hyphen.r foo foo

:p.creates the archive foo.zip, containing all the files  and  directories
in the directory foo that is contained within the current directory.

:p.You  may  want  to  make  a zip archive that contains the files in foo,
without recording the directory name, foo.  You can use the  &hyphen.j  option
to leave off the paths, as in:

:p.       zip &hyphen.j foo foo/*

:p.If  you are short on disk space, you might not have enough room to hold
both the  original  directory  and  the  corresponding  compressed  zip
archive.   In  this case, you can create the archive in steps using the
&hyphen.m option.  If foo contains the subdirectories tom,  dick,  and  harry,
you can:

:p.       zip &hyphen.rm foo foo/tom
:p.       zip &hyphen.rm foo foo/dick
:p.       zip &hyphen.rm foo foo/harry

:p.where  the  first  command creates foo.zip, and the next two add to it.
At the completion of each zip command,  the  last  created  archive  is
deleted, making room for the next zip command to function.
.br

:h1.Pattern Matching
:p.This  section  applies  only  to  UNIX, though the ?, *, and [] special
characters are implemented on other systems including MSDOS and  Win32.
Watch this space for details on MSDOS and VMS operation.

:p.The  UNIX shells (sh(1) and csh(1)) do filename substitution on command
arguments.  The special characters are:

:p.?      match any single character

:p.*      match any number of characters (including none)

:p.[]     match any character in the range indicated within  the  brackets (example: [a&hyphen.f], [0&hyphen.9]).

:p.When  these  characters  are  encountered (without being escaped with a
backslash or quotes), the shell will look for  files  relative  to  the
current  path  that  match the pattern, and replace the argument with a
list of the names that matched.

:p.The zip program can do the same matching on names that are in  the  zip
archive  being  modified  or,  in  the  case  of the &hyphen.x (exclude) or &hyphen.i
(include) options, on the list of files to be  operated  on,  by  using
backslashes  or  quotes to tell the shell not to do the name expansion.
In general, when zip encounters a name in the list of files to  do,  it
first  looks  for the name in the file system.  If it finds it, it then
adds it to the list of files to do.  If it does not find it,  it  looks
for  the  name  in the zip archive being modified (if it exists), using
the pattern matching characters described above, if present.  For  each
match,  it  will  add  that  name to the list of files to be processed,
unless this name matches one given with the  &hyphen.x  option,  or  does  not
match any name given with the &hyphen.i option.

:p.The pattern matching includes the path, and so patterns like \*.o match
names that end in ".o", no matter what the path prefix is.   Note  that
the  backslash must precede every special character (i.e. ?*[]), or the
entire argument must be enclosed in double quotes ("").

:p.In general, use backslash to make zip do the pattern matching with  the
&hyphen.f  (freshen)  and  &hyphen.d  (delete)  options,  and  sometimes after the &hyphen.x
(exclude) option when used with an appropriate operation (add, &hyphen.u,  &hyphen.f,
or &hyphen.d).
.br

:h1.Environment
:p.ZIPOPT
.br
contains default options that will be used when running zip

:p.ZIP
.br
[Not on RISC OS and VMS] see ZIPOPT

:p.Zip$Options
.br
[RISC OS] see ZIPOPT

:p.Zip$Exts
.br
[RISC  OS]  contains extensions separated by a : that will cause
native filenames with one of  the  specified  extensions  to  be
added to the zip file with basename and extension swapped.  zip

:p.ZIP_OPTS
.br
[VMS] see ZIPOPT

:p.SEE ALSO
.br
compress(1), shar(1L), tar(1), unzip(1L), gzip(1L)

:h1.Diagnostics
:p.The exit status (or error level) approximates the exit codes defined by
PKWARE and takes on the following values, except under VMS:

:p.0
.br
normal; no errors or warnings detected.

:p.2
.br
unexpected end of zip file.

:p.3
.br
a generic error in the zipfile format was detected.  Processing may have completed
successfully anyway; some broken zipfiles created by other archivers have simple
work arounds.

:p.4
.br
zip was unable to allocate memory for one or more buffers during program initialization.

:p.5
.br
a severe error in the zipfile format was detected. Processing probably failed immediately.

:p.6
.br
entry too large to split (with zipsplit), read, or write

:p.7
.br
invalid comment format

:p.8
.br
zip &hyphen.T failed or out of memory

:p.9
.br
the user aborted zip prematurely with control&hyphen.C (or similar)

:p.10
.br
zip encountered an error while using a temp file

:p.11
.br
read or seek error

:p.12
.br
zip has nothing to do

:p.13
.br
missing or empty zip file

:p.14
.br
error writing to a file

:p.15
.br
zip was unable to create a file to write to

:p.16
.br
bad command line parameters

:p.18
.br
zip could not open a specified file to read

:p.VMS interprets standard Unix (or PC) return values as  other, scarierlooking
things, so zip instead maps them into VMS&hyphen.style status codes.  The current mapping
is as follows&colon.  1 (success) for normal exit, and (0x7fff000? + 16*normal_zip_exit_status)
for all errors, where the `?' is 0 (warning) for zip value 12, 2 (error)
for the zip values 3, 6, 7, 9, 13, 16, 18, and 4 (fatal error) for the remaining ones.
.br

:h1.Bugs
:p.zip 2.32 is not compatible with PKUNZIP 1.10. Use zip  1.1  to  produce
zip files which can be extracted by PKUNZIP 1.10.

:p.zip  files produced by zip 2.32 must not be updated by zip 1.1 or PKZIP
1.10, if they contain encrypted members or if they have  been  produced
in a pipe or on a non&hyphen.seekable device. The old versions of zip or PKZIP
would create an archive with an incorrect format.  The old versions can
list the contents of the zip file but cannot extract it anyway (because
of the new compression algorithm).  If you do not  use  encryption  and
use regular disk files, you do not have to care about this problem.

:p.Under  VMS, not all of the odd file formats are treated properly.  Only
stream&hyphen.LF format zip files are expected to work with zip.   Others  can
be  converted  using  Rahul  Dhesi's BILF program.  This version of zip
handles some of the conversion internally.  When using Kermit to transfer
zip files from Vax to MSDOS, type "set file type block" on the Vax.
When transferring from MSDOS to Vax, type "set file type fixed" on  the
Vax.  In both cases, type "set file type binary" on MSDOS.

:p.Under  VMS,  zip  hangs  for file specification that uses DECnet syntax
foo&colon.&colon.*.*.

:p.On OS/2, zip cannot match some names, such as those including an excla&hyphen.
mation  mark  or a hash sign.  This is a bug in OS/2 itself: the 32&hyphen.bit
DosFindFirst/Next don't find such names.  Other programs  such  as  GNU
tar are also affected by this bug.

:p.Under  OS/2, the amount of Extended Attributes displayed by DIR is (for
compatibility) the amount returned by the 16&hyphen.bit version  of  DosQueryPathInfo().
Otherwise OS/2 1.3 and 2.0 would report different EA sizes
when DIRing a file.  However, the  structure  layout  returned  by  the
32&hyphen.bit  DosQueryPathInfo()  is  a  bit different, it uses extra padding
bytes and link pointers (it's a linked list)  to  have  all  fields  on
4&hyphen.byte  boundaries for portability to future RISC OS/2 versions. Therefore
the value reported by zip (which uses this 32&hyphen.bit&hyphen.mode size)  differs
from  that  reported  by  DIR.   zip stores the 32&hyphen.bit format for
portability, even the 16&hyphen.bit MS&hyphen.C&hyphen.compiled version running on OS/2 1.3,
so even this one shows the 32&hyphen.bit&hyphen.mode size.

:p.Development  of  zip 3.0  and unzip 6.0 are underway.  See those source
distributions for many new features and the latest bug fixes.
.br

:h1.Authors
:p.Copyright (C) 1997&hyphen.2006 Info&hyphen.ZIP.

:p.Copyright (C) 1990&hyphen.1997 Mark Adler, Richard B. Wales, Jean&hyphen.loup Gailly,
Onno  van  der Linden, Kai Uwe Rommel, Igor Mandrichenko, John Bush and
Paul Kienitz.  Permission is granted to any individual  or  institution
to use, copy, or redistribute this software so long as all of the original
files are included, that it is not sold for profit, and that  this
copyright notice is retained.

:p.LIKE  ANYTHING  ELSE  THAT'S FREE, ZIP AND ITS ASSOCIATED UTILITIES ARE
PROVIDED AS IS AND COME WITH NO WARRANTY OF ANY KIND, EITHER  EXPRESSED
OR  IMPLIED.  IN  NO EVENT WILL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY
DAMAGES RESULTING FROM THE USE OF THIS SOFTWARE.

:p.Please send bug reports and comments to: zip&hyphen.bugs at  www.info&hyphen.zip.org.
For  bug  reports,  please include the version of zip (see zip &hyphen.h), the
make options used to compile it (see zip &hyphen.v), the machine and operating
system in use, and as much additional information as possible.
.br

:h1.Acknowlegements
Thanks  to  R. P. Byrne for his Shrink.Pas program, which inspired this
project, and from which the shrink algorithm was stolen; to  Phil  Katz
for  placing in the public domain the zip file format, compression format,
and .ZIP filename extension, and for accepting  minor  changes  to
the  file  format; to Steve Burg for clarifications on the deflate format;
to Haruhiko Okumura and Leonid Broukhis for providing some  useful
ideas  for  the  compression  algorithm; to Keith Petersen, Rich Wales,
Hunter Goatley and Mark Adler for providing a mailing list and ftp site
for  the  Info&hyphen.ZIP  group to use; and most importantly, to the Info&hyphen.ZIP
group itself (listed in the file infozip.who)  without  whose  tireless
testing  and bug&hyphen.fixing efforts a portable zip would not have been possible.
Finally we should thank (blame) the first  Info&hyphen.ZIP  moderator,
David  Kirschbaum,  for  getting  us into this mess in the first place.
The manual page was rewritten for UNIX by R. P. C. Rodgers.
.br


:euserdoc.
